<template>
	<div v-if="menus.menuseen" class="sidebar-menu">
		<div class="scroll-wrapper menu-items" style="position: relative;">
		  	<div  class="card social-card share share-other full-width">
		      	<div style="margin-top:5px; margin-bottom:-10px;">
					<div class="form-group form-group-default">
			            <input v-on:keyup.enter="search(searchtext,'searchlistseen','mainsearch')" v-model="searchtext" type="text" class="form-control" placeholder="Search" >
			      	</div>
				</div>
		      <div v-if="menus.menubodyseen" class="card-body">
		      	<button @click="switchMenu('direction')" type="button" class="btn btn-block btn-default">
                  	<span class="pull-left"><i class="fa fa-deviantart"></i>
                </span>Direction</button>
                <button type="button" @click="getEvacuationArea" class="btn btn-block btn-default">
                  	<span class="pull-left"><i class="fa fa-dot-circle-o"></i>
                </span>Evacuation Point</button>
                <button @click="getParkiran" type="button" class="btn btn-block btn-default">
                  	<span class="pull-left"><i class="fa fa-car"></i>
                </span>Park info</button>
                <button @click="getEventKampus" type="button" class="btn btn-block btn-default">
                  	<span class="pull-left"><i class="fa pg-calender"></i>
                </span>Event</button>
                <button @click="getInfoBus" type="button" class="btn btn-block btn-default">
                  	<span class="pull-left"><i class="fa fa-bus"></i>
                </span>Shuttle Bus</button>
		      </div>
		      <div v-if="menus.searchlistseen">
		      	<div class="card-body" style="margin-top:-15px">
			        
		              <li class="pull-right">
		                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
						</a>
		              </li>
	        	</div>
		        <div v-for="point in points" class="card-header clearfix last" >
		        	<div @click="getMarker(point)">
		        		<h5>{{point.type}} - {{point.id}}</h5>
			        	<h6>lat : {{point.lat}} , lng : {{point.lng}}</h6>
		        	</div>
		        </div>
		      </div>
		      <div v-if="menus.direction">
		      	<div class="card-body" style="margin-top:-15px">
	              <li class="pull-right">
	                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
					</a>
	              </li>
	        	</div>
		        <div class="card-body clearfix last" >
		        	<div class="form-group form-group-default">
			      		<input v-on:keyup="search(direction.origin.id,'direction','origin')" v-model="direction.origin.id" class="typeahead form-control sample-typehead tt-input" type="text" placeholder="Origin" autocomplete="off" spellcheck="false" dir="auto" style="position: relative; vertical-align: top; background-color: transparent;">
			      	</div>
			      	<div class="form-group form-group-default">
			            <input v-on:keyup="search(direction.destination.id,'direction','destination')" v-model="direction.destination.id" class="typeahead form-control sample-typehead tt-input" type="text" placeholder="Destination" autocomplete="off" spellcheck="false" dir="auto" style="position: relative; vertical-align: top; background-color: transparent;">
			      	</div>
			      	<div v-if="menus.listdirection" v-for="point in points" class="card-header clearfix last" >
			        	<div @click="selectPoint(point,source)">
			        		<h5>{{point.type}} - {{point.id}}</h5>
				        	<h6>lat : {{point.lat}} , lng : {{point.lng}}</h6>
			        	</div>
		        	</div>
		        </div>
		      </div>
		      <div v-if="menus.parkiran">
		      	<div class="card-body" style="margin-top:-15px">
	              <li class="pull-right">
	                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
					</a>
	              </li>
	              <h5>Campus Park Information</h5>
	        	</div>

			      <div class="card-body">
			      	<button @click="toggleSimulation()" type="button" class="btn btn-block btn-default">
			          	<span class="pull-left"><i class="fa fa-gear"></i>
			        </span>{{message}}</button>
			      </div>

		        <div class="card-body" >
			      	<div v-if="menus.listparkiran" v-for="point in points_parkiran" class="card-header clearfix last" >
			        	<div @click="selectPoint(point,source='parkiran')">
			        		<h5>{{point.type}} - {{point.id}}</h5>
				        	<h6>lat : {{point.lat}} , lng : {{point.lng}}</h6>
			        	</div>
		        	</div>
		        </div>
		      </div>
		      <div v-if="menus.evacuation">
		      	<div class="card-body" style="margin-top:-15px">
	              <li class="pull-right">
	                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
					</a>
	              </li>
	              <h5>Campus Evacuation Area</h5>
	        	</div>
		        <div class="card-body" >
			      	<div v-if="menus.listevacuation" v-for="point in points_evacuation" class="card-header clearfix last" >
			        	<div @click="selectPoint(point,source=null)">
			        		<h5>{{point.type}} - {{point.id}}</h5>
				        	<h6>lat : {{point.lat}} , lng : {{point.lng}}</h6>
			        	</div>
		        	</div>
		        </div>
		      </div>
		      <div v-if="menus.eventkampus">
		      	<div class="card-body" style="margin-top:-15px">
	              <li class="pull-right">
	                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
					</a>
	              </li>
	              <h5>Campus Event</h5>
	        	</div>
		        <div class="card-body" >
			      	<div v-if="menus.listeventkampus" v-for="point in points_eventkampus" class="card-header clearfix last" >
			        	<div @click="selectPoint(point,source='eventkampus')">
			        		<h5>{{point.judul}}</h5>
				        	<h6>{{point.waktu}} - {{point.tempat}}</h6>
			        	</div>
		        	</div>
		        </div>
		      </div>
		      <div v-if="menus.shuttlebus">
		      	<div class="card-body" style="margin-top:-15px">
	              <li class="pull-right">
	                <a href="#" @click="switchMenu('menubodyseen')"><i class="fa fa-close"></i>
					</a>
	              </li>
	              <h5>Shuttle Bus</h5>
	        	</div>
	        	<div class="card-body" >
			      	<div v-for="point in points_shuttlebus" class="card-header clearfix last" >
			        	<div>
			        		<h5>{{point.rute}}</h5>
				        	<h6>{{point.operasional}} - {{point.jam_berangkat}}</h6>
				        	<h6>{{point.pool}}-{{point.telp}}</h6>
			        	</div>
		        	</div>
		        </div>
		        <div class="card-body" >
			      	<div v-for="point in points_poolbus" class="card-header clearfix last" >
			        	<div @click="selectPoint(point,source=null)">
				        	<h6>pool - {{point.name}}</h6>
			        	</div>
		        	</div>
		        </div>
		      </div>
		    </div>
	    </div>
	</div>
</template>


<script>
import EventBus from '../eventbus';
import {mapGetters} from 'vuex';

export default {
  	name: 'google-menu',
  
	data: function () {
		return {
			searchtext:'',
			marker:[],
			menus:{
				'menuseen':true,
				'menubodyseen':true,
				'searchlistseen':false,
				'direction':false,
				'listdirection':false,
				'parkiran':false,
				'listparkiran':false,
				'evacuation':false,
				'listevacuation':false,
				'eventkampus':false,
				'listeventkampus':false,
				'shuttlebus':false
			},
			direction:{ 
				origin:{
					id:'',
					type: '',
					lat:'',
					lng:''
				},
				destination:{
					id:'',
					type: '',
					lat:'',
					lng:''
				}
			},
			source:'',
			simulation : false,
			message: 'start simulation',
			timer: ''
			
		}
	},
	created() {
	 	EventBus.$on('menuseen', this.setMenu);
	 	EventBus.$on('directionRequest', this.directionRequest);
	},
	beforeDestroy() {
		EventBus.$off('menuseen');
		EventBus.$off('directionRequest');
	},
	methods: {
		resetPoint: function(){
			this.direction = { 
				origin:{
					id:'',
					type: '',
					lat:'',
					lng:''
				},
				destination:{
					id:'',
					type: '',
					lat:'',
					lng:''
				}
			};
			this.marker = [];
		},
		setMenu(menuseen){
	 		this.menus.menuseen = menuseen;
		},
		search: function(searchtext,menu,source){
			this.$store.dispatch('searchPoints',searchtext);  
			this.switchMenu(menu);
			if(menu == 'direction'){
				this.menus.listdirection=true;
			}

			this.source = source;
		},
		directionRequest: function(point){
			this.resetPoint();
			this.selectPoint(point,'destination');
			// this.selectPoint(point,'origin');
			this.switchMenu('direction');
		},
		selectPoint: function(point,source){
			EventBus.$emit('resetDisplay');

			if(source == 'origin' || source == 'destination'){
				if(source == 'origin'){
					this.direction.origin = point;
				}else{
					this.direction.destination = point;
				}
				this.menus.listdirection = false; 
				EventBus.$emit('location', this.direction);
			}else if(source == 'parkiran'){
				this.marker[0] = point;
				EventBus.$emit('markersParkiran', this.marker);
				EventBus.$emit('detailParkiran', point);
			}else if(source == 'eventkampus'){
				this.marker[0] = point;
				EventBus.$emit('markers', this.marker);
				EventBus.$emit('detailEvent', point);
			}else{
				this.marker[0] = point;
				EventBus.$emit('markers', this.marker);
				EventBus.$emit('detailParkiran', point);
			}
			
		},
		switchMenu: function(menu_id){

			for (var key in this.menus) {
		        
		        if (key == menu_id){
		        	this.menus[key] = true;
		        }else if(key == 'menuseen'){
		        	this.menus['menuseen'] = true;
		        }
		        else{
		        	this.menus[key] = false;
		        }
		    }

		    EventBus.$emit('resetDisplay');
		    this.searchtext = '';
		},
		getMarker: function(point){
			console.log(point);
			this.marker[0] = point;
			EventBus.$emit('markers', this.marker);
			EventBus.$emit('detail', this.marker[0].id);
			// console.log(point);
		},
		getParkiran: function(){
			this.switchMenu('parkiran');
			this.menus.listparkiran=true;
			this.$store.dispatch('getParkiran','all');

	 		this.$store.watch(
		      (state, getters) => getters.points_parkiran,
		      (newValue, oldValue) => {
		      	console.log(newValue);
		        EventBus.$emit('markersParkiran', newValue);
		      },
		    );
		},
		getEvacuationArea: function(){
			this.switchMenu('evacuation');
			this.menus.listevacuation=true;
			this.$store.dispatch('getEvacuationArea','all');

	 		this.$store.watch(
		      (state, getters) => getters.points_evacuation,
		      (newValue, oldValue) => {
		      	console.log(newValue);
		        EventBus.$emit('markers', newValue);
		      },
		    );
		},
		toggleSimulation: function(){
			if(this.simulation == false){
				this.simulation = true;
				this.message = 'stop simulation';
				this.timer = setInterval(this.startSimulation, 5000);
				// this.startSimulation();
			}else{
				this.simulation = false;
				this.message = 'start simulation';
				this.stopSimulation();
			}
		},
		startSimulation: function(){
			this.$store.dispatch('simulateParkiran');
		},
		stopSimulation: function(){
			clearInterval(this.timer);
		},
		getEventKampus: function(){
			this.switchMenu('eventkampus');
			this.menus.listeventkampus=true;
			this.$store.dispatch('getEventKampus');

	 		this.$store.watch(
		      (state, getters) => getters.points_eventkampus,
		      (newValue, oldValue) => {

		      	console.log(newValue);
		        EventBus.$emit('markers', newValue);
		      },
		    );
		},
		getInfoBus: function(){
			this.switchMenu('shuttlebus');
			this.$store.dispatch('getShuttleBus');
			this.$store.dispatch('getPoolBus');

		    this.$store.watch(
		      (state, getters) => getters.points_poolbus,
		      (newValue, oldValue) => {

		      	console.log(newValue);
		        EventBus.$emit('markers', newValue);
		      },
		    );
		},
	},
	computed: {
        ...mapGetters([
            'points','datapoint','points_parkiran','points_evacuation','points_eventkampus','points_shuttlebus','points_poolbus'
        ])
    }

};
</script>